package org.jabricks.templates;

/**
 * Активатор бандла создания фрейма OSGi приложения 
 * с использованием JFrame библиотеки SWING 
 */

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import org.jabricks.jframe.JBFrameActivator;
import org.osgi.framework.BundleContext;
import org.osgi.framework.BundleActivator;
import org.osgi.framework.ServiceListener;

public class JFrameActivator extends JBFrameActivator implements BundleActivator, ServiceListener
{
	private  final  String   MENU_exit    = "menu.exit"   ;
	private  final  String   TOOLBAR_exit = "toolbar.exit";
	//-----------------------------------------------------------------------------------------------------------------
	/**
	 * Процедура старта; вызывается фреймворком.
	 * @param context   
	 */
    public void start(final BundleContext context) throws Exception
    {
    	super.start (context);

    	createLocaleSubscriber ();
//    	createConnectSubscriber();
    	createJFrameSubscriber ();
    	
    	createMenuListener     ();
    	createToolbarListener  ();
    	createWindowListener   ();
    	
        frame = new JFrameTempl(context); 
        ((JFrameTempl)frame).createJFrame(menuListener, toolbarListener);
        
        // Завершение работы программы при выборе пункта меню MENU_exit
        if (frame.getMenuService() != null) {
        	frame.getMenuService().addActionListener(MENU_exit, new ActionListener() {
        		public void actionPerformed(ActionEvent action) {
        			stop();
        		}
        	});
        }
        // Завершение работы программы при нажатии на кнопку панели инструментов TOOLBAR_exit
        if (frame.getToolbarService() != null) {
	        frame.getToolbarService().addActionListener(TOOLBAR_exit, new ActionListener() {
	        	public void actionPerformed(ActionEvent action) {        	
	        		stop();
	            }
	        });
        }
        frame.getJFrame().addWindowListener(windowListener);    	
    }
	//-----------------------------------------------------------------------------------------------------------------
	/**
	 * метод сохранения параметров настроек интерфейса. Вызывается перед остановкой бандла.
	 */
	public void saveJFrameData() 
	{
		frame.saveJFrameData();
	}
    //-----------------------------------------------------------------------------------------------------------------
}
